/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2007 EBM Websourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * $Id$
 * -------------------------------------------------------------------------
 */

package org.ow2.petals.tools.webadmin.ui.infra.bean;

import java.util.ArrayList;
import java.util.List;

/**
 * Component Light Value Object
 * 
 * @author mcarpentier - EBM Websourcing
 * 
 */
public class ComponentLVO {

    public static String BC_TYPE = "Binding component";

    public static String SE_TYPE = "Service Engine";

    private String name;

    private String state;

    private String type;

    private String description;

    private String objectName;

    private List<QueueLVO> queues;

    private List<EndPointLVO> endpoints;

    public String getDescription() {
        return description;
    }

    public String getName() {
        return name;
    }

    public ComponentLVO(String name, String state) {
        super();
        this.name = name;
        this.state = state;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getState() {
        return state;
    }

    public void setState(String state) {
        this.state = state;
    }

    public String getType() {
        return type;
    }

    public void setType(String type) {
        this.type = type;
    }

    public void setDescription(String description) {
        this.description = description;

    }

    public String getObjectName() {
        return objectName;
    }

    public void setObjectName(String objectName) {
        this.objectName = objectName;
    }

    public void addQueue(QueueLVO q) {
        if (getQueues() == null) {
            this.queues = new ArrayList<QueueLVO>();
        }
        this.queues.add(q);
    }

    public void addEndpoint(EndPointLVO ep) {
        if (getEndpoints() == null) {
            this.endpoints = new ArrayList<EndPointLVO>();
        }
        this.endpoints.add(ep);
    }

    public EndPointLVO getEndpoint(String serviceName, String endpointName) {
        if (getEndpoints() != null) {
            for (EndPointLVO ep : getEndpoints()) {
                if ((serviceName.equalsIgnoreCase(ep.getService()))
                        && (endpointName.equalsIgnoreCase(ep.getName()))) {
                    return ep;
                }
            }
        }
        return null;
    }

    public List<QueueLVO> getQueues() {
        return queues;
    }

    public List<EndPointLVO> getEndpoints() {
        return endpoints;
    }

    public void setEndpoints(List<EndPointLVO> endpoints) {
        this.endpoints = endpoints;
    }
}
