/**
 * PETALS - PETALS Services Platform. Copyright (c) 2007 EBM Websourcing,
 * http://www.ebmwebsourcing.com/
 * 
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version. This library is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 * 
 * -------------------------------------------------------------------------
 * $Id$
 * -------------------------------------------------------------------------
 */

package org.ow2.petals.tools.webadmin.ui.logon;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.log4j.Logger;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.ow2.petals.tools.webadmin.cron.CollectorManager;
import org.ow2.petals.tools.webadmin.ui.administration.InstallComponent;
import org.ow2.petals.tools.webadmin.ui.infra.session.AdminSession;

/**
 * action to display the login form
 * 
 * @author mcarpentier - EBM Websourcing
 * 
 */
public class ShowLogon extends Action {

    final Logger log = Logger.getLogger(InstallComponent.class);

    @Override
    public ActionForward execute(ActionMapping iActionMapping, ActionForm form,
            HttpServletRequest iRequest, HttpServletResponse iResponse) throws Exception {

        AdminSession session = AdminSession.getAdminSession(iRequest.getSession());
        if (CollectorManager.isCollectorInitialized()) {
            /** collector has been configured **/
            if (session.getUser() != null) {
                /** user is logged * */
                if (session.getUser().isAdmin()) {
                    return iActionMapping.findForward("admin_success");
                } else {
                    return iActionMapping.findForward("monitoring_success");
                }
            } else {
                return iActionMapping.findForward("logon");
            }
        } else {
            return iActionMapping.findForward("success");
        }
    }
}
