/**
 * 
 */
package org.ow2.petals.tools.webadmin.util;

import java.io.File;
import java.io.IOException;

/**
 * @author aruffie
 * Class allow you to set rights on several
 */
public class FilePermissionHelper {

    /**
     * Allow you to set many several rights on the
     * file provided
     * 1 execute, 2 = write, 3 = write,execute
     * 4 = read, 5 = read/execute
     * 6 = read/write, 7 =read/write/execute
     * asynch : true (Asynchronous mode) /
     * false (Synchronous mode)
     * @param file
     * @param rights
     * @param asynch
     * @throws IOException
     */
    public static void setRights(File file, int[] rights, boolean asynch) throws IOException{
         
      // 4 = read, 2 = write, 1 = execute
      if(file == null){
          throw new IOException("File cannot be null");
      }
      if(rights.length != 3){
          throw new IllegalArgumentException("rights[] must be 3 example: [7][7][7]");
      }
      for(int i : rights){
          if ((i<0)&&(i>7)){
              throw new IllegalArgumentException("Rights must be -1<r<8 ");
          }
      }
      
      Runtime runtime = Runtime.getRuntime();
      
      String command = null;
      if(System.getProperty("os.name").equals("Linux")){
      //pour unix
        command= "chmod -R "+rights[0]+rights[1]+rights[2]+" "+file.getAbsolutePath();
      
      }
      if(System.getProperty("os.name").equals("Windows")){
          //pour windows
          //throw new IllegalStateException("Plateform: "+System.getProperty("os.name")+" not supported");
          //runtime.exec("cacls.exe "+file.getAbsolutePath()+" "+permission});
      }
      Process process = runtime.exec(command);
      
      if(!asynch){
          synchronized(process){
              try {       
                process.waitFor();
              } catch (InterruptedException e) {
                // TODO Auto-generated catch block
                e.printStackTrace();
              }
          }
      }
   }
    
    
   /**
    * Function allow you to set rights
    * read/write/exec, on the zip provided
    * 1 execute, 2 = write, 3 = write,execute
    * 4 = read, 5 = read/execute
    * 6 = read/write, 7 =read/write/execute
    * asynch : true (Asynchronous mode) /
    * false (Synchronous mode)
    * @param zip
    * @param rights
    * @param asynch
    * @throws IOException
    */
   public static void setRightInZip(File zip, int[] rights, boolean asynch) throws IOException{
       
       Runtime runtime = Runtime.getRuntime();
       
       String command = null;
       String dirPath = zip.getAbsolutePath().substring(0, (int)zip.getAbsolutePath().length()-4);
       
       if(System.getProperty("os.name").equals("Linux")){
       //pour unix      
         command= "unzip -X "+zip.getAbsolutePath()+" -d "+dirPath;
       }
       if(System.getProperty("os.name").equals("Windows")){
           
       }
       //unzip all file in /zip.name directory
       Process process = runtime.exec(command);
       if(!asynch){
           synchronized(process){
               try {       
                 process.waitFor();
               } catch (InterruptedException e) {
                 // TODO Auto-generated catch block
                 e.printStackTrace();
               }
           }
       }
       
       
       
       if(System.getProperty("os.name").equals("Linux")){
           //pour unix      
             command= "zip -r "+zip.getAbsolutePath();
      }
       if(System.getProperty("os.name").equals("Windows")){
           
       }
       File directory = new File(dirPath);
       //Re-allow all rights
       for(File f: directory.listFiles()){
           if((f.isFile())||(f.getName().equals("META-INF"))){
               setRights(f, rights, false);   
               command+=" "+dirPath+"/"+f.getName();
               System.out.println("command: "+command);
           } 
       }
       
       //rezip all files
      runtime.exec(command);
      if(!asynch){
          synchronized(process){
              try {       
                process.waitFor();
              } catch (InterruptedException e) {
                // TODO Auto-generated catch block
                e.printStackTrace();
              }
          }
      }
      
      //Eligeable for gc
      command = null;
      dirPath = null;
      directory = null;
       
   }
}

